#!/bin/sh
#
# Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
# PROPRIETARY/CONFIDENTIAL.  Use of this product is subject to license terms.
#

# Override PS_CONFIG_DIR dirctory in next line if needed

# If the config location is not set use the platform defaults
if [ -z "$PS_CONFIG_DIR" ]; then
   PS_CONFIG_DIR=/etc/opt/SUNWportal
   OSTYPE=`/bin/uname -s`
   if [ "$OSTYPE" = "Linux" ]; then
      PS_CONFIG_DIR=/etc/opt/sun/portal
   fi
fi
PS_CONFIG_FILE=${PS_CONFIG_DIR}/PSConfig.properties

# Set variables from data in PSConfig.properties
JAVA_HOME=`grep "^java.home=" $PS_CONFIG_FILE | sed -e "s/java.home=//"`
SHARED_LIB_DIR=`grep "^shared.lib.location=" $PS_CONFIG_FILE | sed -e "s/shared.lib.location=//"`
PRIVATE_LIB_DIR=`grep "^private.lib.location=" $PS_CONFIG_FILE | sed -e "s/private.lib.location=//"`
AM_DIR=`grep "^am.product.location=" $PS_CONFIG_FILE | sed -e "s/am.product.location=//"`
AM_CONFIG_DIR=`grep "^am.config.location=" $PS_CONFIG_FILE | sed -e "s/am.config.location=//"`
PS_DIR=`grep "^ps.product.location=" $PS_CONFIG_FILE | sed -e "s/ps.product.location=//"`
PS_DATA_DIR=`grep "^ps.data.location=" $PS_CONFIG_FILE | sed -e "s/ps.data.location=//"`
PS_DEFAULT_PORTAL=`grep "^ps.default.portal=" $PS_CONFIG_FILE | sed -e "s/ps.default.portal=//"`
JSS_NSS_LIB_DIR=`grep "^jss.nss.lib.location=" $PS_CONFIG_FILE | sed -e "s/jss.nss.lib.location=//"`
JSS_JAR_DIR=`grep "^jss.jar.location=" $PS_CONFIG_FILE | sed -e "s/jss.jar.location=//"`
JDMK_LIB_DIR=`grep "^jdmk.lib.location=" $PS_CONFIG_FILE | sed -e "s/jdmk.lib.location=//"`
CACAO_DIR=`grep "^cacao.product.location=" $PS_CONFIG_FILE | sed -e "s/cacao.product.location=//"`

CACAO_LIB_DIR=$CACAO_DIR/lib
CACAO_SHARE_LIB_DIR=$CACAO_DIR/share/lib
LD_LIBRARY_PATH="$JSS_NSS_LIB_DIR:$JAVA_HOME/jre/lib/i386/native_threads:$LD_LIBRARY_PATH"
export LD_LIBRARY_PATH

SHARED_COMPONENTS="$JSS_JAR_DIR/jss4.jar:$PRIVATE_LIB_DIR/ktsearch.jar:$SHARED_LIB_DIR/ldapjdk.jar:$SHARED_LIB_DIR/jaxp-api.jar:$SHARED_LIB_DIR/mail.jar:$SHARED_LIB_DIR/xercesImpl.jar:$SHARED_LIB_DIR/xalan.jar:$SHARED_LIB_DIR/dom.jar:$SHARED_LIB_DIR/sax.jar:$JDMK_LIB_DIR/jmxremote_optional.jar:$CACAO_LIB_DIR/cacao_cacao.jar:$CACAO_SHARE_LIB_DIR/cacao_cacao.jar"
EXTERNAL_CLASSPATH="$AM_DIR/locale:$AM_DIR/lib:$AM_DIR/lib/am_sdk.jar:$AM_DIR/lib/am_services.jar:$AM_DIR/lib/servlet.jar:$AM_DIR/lib/jaas.jar:$SHARED_COMPONENTS"
UBTREPORTS_CLASSPATH="$PS_DIR/lib/jasperreports.jar:$PS_DIR/lib/jfreechart.jar:$PS_DIR/lib/itext.jar:$PS_DIR/lib/jcommon.jar:$PS_DIR/lib/commons-beanutils.jar:$PS_DIR/lib/commons-collections.jar:$PS_DIR/lib/commons-digester.jar:$PS_DIR/lib/commons-logging.jar:$PS_DIR/lib/ubtadmin.jar:$PS_DIR/lib/ubtreport.jar:$PS_DIR/lib/admin_cli_ubt.jar:"
PS_CLASSPATH="$PS_CONFIG_DIR/:$PS_DIR/locale:$PS_DIR/lib:$PS_DIR/lib/ps_util.jar:$PS_DIR/lib/pslogcommon.jar:$PS_DIR/lib/cli-framework.jar:$PS_DIR/lib/admin_cli.jar:$PS_DIR/lib/admin_cli_rewriter.jar:$PS_DIR/lib/admin_cli_search.jar:$PS_DIR/lib/admin_cli_subscriptions.jar:$PS_DIR/lib/admin_cli_desktop.jar:$PS_DIR/lib/admin_cli_monitoring.jar:$PS_DIR/lib/admin_cli_logging.jar:$PS_DIR/lib/admin_cli_sra.jar:$PS_DIR/lib/admin_cli_wsrp.jar:$PS_DIR/lib/admin_cli_ssoadapter.jar:$PS_DIR/lib/admin_common.jar:$PS_DIR/lib/fabric.jar:$PS_DIR/lib/rwportal.jar:$PS_DIR/lib/rewriter.jar:$PS_DIR/lib/desktop.jar:$PS_DIR/lib/searchserver.jar:$PS_DIR/lib/subscriptions.jar:$PS_DIR/lib/db.jar:$PS_DIR/lib/jdom.jar:$PS_DIR/lib/monitoring.jar:$PS_DIR/lib/admin_cli_portlet.jar:$UBTREPORTS_CLASSPATH"
CLASSPATH="$PS_DIR/lib/config.jar:$PS_CLASSPATH:$EXTERNAL_CLASSPATH:$JAVA_HOME/lib/lib.zip:$PS_DIR/lib"
export CLASSPATH

