<!-- AccountPreferencesContainer/content.jsp -->
<%@ taglib uri="/tld/desktopProviderContext.tld" prefix="dtpc"
%><%@ taglib uri="/tld/desktopContainerProviderContext.tld" prefix="dtcpc"
%><%@ taglib uri="/tld/desktop.tld" prefix="dt"
%><%@ taglib uri="/tld/jx.tld" prefix="jx"
%><%@ taglib uri="/tld/i18n.tld" prefix="i18n"
%><%@ page import="java.util.*, java.net.URLEncoder, java.io.UnsupportedEncodingException"%>

<dt:obtainContainer container="$JSPProvider">

  <i18n:setBundle baseName="CommunitySamplePortal" var="CommunitySamplePortalRB"/>
  <jx:declare id="CommunitySamplePortalRB" type="java.util.ResourceBundle"/>

  <%
    /* These are constants shared by content and process jsps and
     * refer to the state of the processing (saving) of account prefs
     */
    String COMPLETE = "complete";
    String INCOMPLETE = "incomplete";
    String ERROR = "error";

    // The params for pages
    List titles = new ArrayList();
    titles.add("password");
    titles.add("contactinfo");
    titles.add("timezone");

    String startPage = "password";

    /* The current page can be one of the following:
     * 1. the start page
     * 2. the user clicked on another page to make it the current page
     * 3. the user is returing from saving changes via the process form and so the 
     *    current page is in the session and so it's state must be "reset".
     */

    String accountPrefsPage = startPage;
    if ((String)request.getParameter("accountPrefsPage") != null) {
      accountPrefsPage = (String)request.getParameter("accountPrefsPage");
    } else if ((String)session.getAttribute("accountPrefsPage") != null &&
      !((String)session.getAttribute("accountPrefsPage")).equals(INCOMPLETE)) {

      accountPrefsPage = (String)session.getAttribute("accountPrefsPage");
      session.setAttribute("accountPrefsPage", INCOMPLETE);
    }
    String accountPrefsPageContent = accountPrefsPage + "/" + "content.jsp";
    String accountPrefsFormValidation = accountPrefsPage + "/" + "contentFormValidation.jsp";
    %>

  <jsp:include page="header.jsp" flush="true"/>

  <div id="prefscontainer">                                                                                               

    <div id="title">
      <dtpc:getStringAttribute key="cn"/> &mdash; <i18n:message key="accountpreferences" bundle="CommunitySamplePortalRB"/>
    </div>


    <div id="tabs">

      <span id="separator-first">|</span>

      <%
        Iterator i = titles.iterator();

        while (i.hasNext()) {

          String title = (String)i.next();
          String localizedTitle = CommunitySamplePortalRB.getString(title);

          if (title.equals(accountPrefsPage)) {
            %><span id="selected"><%=localizedTitle%></span><%
          } else {
            %><a href="<dtpc:getDesktopURL/>?provider=AccountPreferencesContainer&accountPrefsPage=<%=title%>&last=false"><%=localizedTitle%></a><%
          }

          %><span class="separator">|</span><%

      } %> 

    </div><!-- end tabs -->

      <table cellpadding="0" cellspacing="0" width="100%" class="channel-frame">
        <tr valign="middle">
          <td class="channel-frame-title">
            Change <%=CommunitySamplePortalRB.getString(accountPrefsPage)%>
          </td>
          <td class="channel-frame-menu"></td>
          </tr>
        </table> 

      <div class="channel-hasFrame-border"> 

        <%
          /*
           * This url is also the return url of the included forms process action and so
           * given the state html about the result of the process action may get included.
           */
          String accountPrefsState = null;
          if (session.getAttribute( "accountPrefsState" ) != null &&
            !session.getAttribute( "accountPrefsState" ).equals(INCOMPLETE)) {

            accountPrefsState = (String)session.getAttribute( "accountPrefsState" );
            String accountPrefsStatePageContent = accountPrefsPage + "/" + accountPrefsState + ".jsp";
        %>

          <%-- Include info about result of pressing "Save Changes" button. --%>
          <jsp:include page="<%=accountPrefsStatePageContent%>" flush="true"/>
          <% } %>

        <!-- include page with javascript for client-side form validation -->
        <jsp:include page="<%=accountPrefsFormValidation%>" flush="true"/>

        <form action="<dtpc:getDesktopURL/>?provider=AccountPreferencesContainer&last=false" 
              target="_parent" method="POST" name="contentForm" 
              enctype="application/x-www-form-urlencoded">

          <input type=hidden name="action" size=-1 value="process">
          <input type=hidden name="provider" size=-1 value="AccountPreferencesContainer">
          <input type=hidden name="accountPrefsPage" size=-1 value="<%=accountPrefsPage%>">
          <input type=hidden name="redirect" size=-1 value="<dtpc:getDesktopURL/>?provider=AccountPreferencesContainer&accountPrefsPage=<%=accountPrefsPage%>&last=false">

          <table cellpadding="4" cellspacing="2" border="0">
            <jsp:include page="<%=accountPrefsPageContent%>" flush="true"/>
          </table>

          <div id="buttonrow">
            <input style="vertical-align: middle" class="Btn2" type="button" name="save" id="save" value="<i18n:message key="save.changes" bundle="CommunitySamplePortalRB"/>" onMouseOver="if (this.disabled==0) this.className='Btn2Hov'" onFocus="if (this.disabled==0) this.className='Btn2Hov'" onMouseOut="if (this.disabled==0) this.className='Btn2'" onBlur="if (this.disabled==0) this.className='Btn2'" onClick="if (contentFormValid()) this.form.submit();" onKeyPress="if (contentFormValid()) this.form.submit();" title="<i18n:message key="save.changes.button" bundle="CommunitySamplePortalRB"/>"/>
            <input style="vertical-align: middle" class="Btn2" type="reset" name="reset" id="reset" value="<i18n:message key="reset" bundle="CommunitySamplePortalRB"/>" onMouseOver="if (this.disabled==0) this.className='Btn2Hov'" onFocus="if (this.disabled==0) this.className='Btn2Hov'" onMouseOut="if (this.disabled==0) this.className='Btn2'" onBlur="if (this.disabled==0) this.className='Btn2'" onClick="" onKeyPress="" title="<i18n:message key="reset.button" bundle="CommunitySamplePortalRB"/>"/>
            <input style="vertical-align: middle" class="Btn2" type="button" name="finished" id="finished" value="<i18n:message key="finished" bundle="CommunitySamplePortalRB"/>" onMouseOver="if (this.disabled==0) this.className='Btn2Hov'" onFocus="if (this.disabled==0) this.className='Btn2Hov'" onMouseOut="if (this.disabled==0) this.className='Btn2'" onBlur="if (this.disabled==0) this.className='Btn2'" onClick="location.href='<dtpc:getDesktopURL/>?provider=CommunityParentContainer&CommunityParentContainer.selectedChannel=CommunityHomeContainer'" onKeyPress="location.href='<dtpc:getDesktopURL/>?provider=CommunityParentContainer&CommunityParentContainer.selectedChannel=CommunityHomeContainer'" title="<i18n:message key="finished.button" bundle="CommunitySamplePortalRB"/>"/>
          </div><!-- end buttonrow -->

        </form>

      </div><!-- end channel-hasFrame-border -->

  </div><!-- end prefscontainer -->

  <%
    /* The state must be reset so the next time through the state is not the "old" state. */
    session.setAttribute("accountPrefsState", INCOMPLETE);
  %>

</dt:obtainContainer><%

%><%@ include file="footer.html"%> 
