<%@ page import="java.security.Principal,
javax.security.auth.*,
javax.security.auth.login.*,
javax.security.auth.callback.*,
com.iplanet.am.sdk.AMStoreConnection,
com.iplanet.am.sdk.AMUser,
com.sun.identity.authentication.AuthContext,
com.sun.identity.authentication.spi.AuthLoginException,
com.iplanet.sso.*,
com.sun.portal.providers.containers.jsp.single.JSPSingleContainerProvider"%><%
%>

<%@ taglib uri="/tld/jx.tld" prefix="jx"%>

<jx:declare id="CommunitySamplePortalRB" type="java.util.ResourceBundle"/>

<%!
// access manager auth context for authenticating users
AuthContext.IndexType indexType;

// membership authentication service
String indexName = "Membership";

/*
 * This method verifies that the old password is valid before
 * the user can change their password.
 * 
 * @param token     user SSOToken
 * @param password  user password 
 * @throws Exception
 */
public boolean verifyOldPassword(SSOToken token, String password) 
  throws Exception {

    // initialize access manager authentication context with ssotoken
    AuthContext lc = null;

    try {
        lc = new AuthContext(token);
        indexType = AuthContext.IndexType.MODULE_INSTANCE;
        lc.login(indexType, indexName);
        String uid = getUid(token);

        Callback[] callbacks = null;
        while (lc.hasMoreRequirements()) {
            callbacks = lc.getRequirements();
            if (callbacks != null) {
                addLoginCallbacks(callbacks, uid, password);
                lc.submitRequirements(callbacks);
            }
        }
    } catch (AuthLoginException le) {
        return false;
    } catch (Exception e) {
        return false;
    } 

    if (lc.getStatus() == AuthContext.Status.SUCCESS) {
        return true;
    } 

    return false;
}

/*
 * Add Login Callbacks
 *
 * @param uid       user id
 * @param password  user password
 * @throws Exception
 */
public void addLoginCallbacks(Callback[] callbacks,
                              String uid,
                              String password) 
  throws Exception {
    int i = 0;

    for (i = 0; i < callbacks.length; i++) {
        if (callbacks[i] instanceof NameCallback) {
            NameCallback nc = (NameCallback) callbacks[i];
            nc.setName(uid);
        } else if (callbacks[i] instanceof PasswordCallback) {
            PasswordCallback pc = (PasswordCallback) callbacks[i];
            pc.setPassword(password.toCharArray());
        } 
    }
}

/*
 * Retrieve user id
 *
 * @param token     user SSOToken
 * @throws Exception
 * @returns uid
 */
public String getUid(SSOToken token) throws Exception {
    AMStoreConnection amsc   = null;
    AMUser            amuser = null;
    String            uid    = "";

    if (token != null) {
        amsc   = new AMStoreConnection(token);
        amuser = amsc.getUser(token.getPrincipal().getName());
        uid    = amuser.getStringAttribute("uid");
    }

  return uid;
}



%>

%>

<%
 /* These are constants shared by content and process jsps and
  * refer to the state of the processing (saving) of account prefs
  */
String COMPLETE = "complete";
String INCOMPLETE = "incomplete";
String ERROR = "error";

JSPSingleContainerProvider scp =
        (JSPSingleContainerProvider)pageContext.getAttribute("JSPProvider");

String key = "userpassword";
String originalPassword = (String)request.getParameter("originalPassword");
String newPassword = (String)request.getParameter("newPassword");

if (originalPassword != null && newPassword != null) {
  try {
    SSOTokenManager tokenManager = SSOTokenManager.getInstance();
    SSOToken token = tokenManager.createSSOToken(request);

    if (verifyOldPassword(token, originalPassword)) {
        scp.setStringAttribute(key, newPassword);
        session.setAttribute("accountPrefsState", COMPLETE);
    } else {
        throw new SSOException("login failed");
    } 
  } catch (SSOException ssoe) {
    session.setAttribute("accountPrefsErrMsg", CommunitySamplePortalRB.getString("password.incorrect"));
    session.setAttribute("accountPrefsState", ERROR);
  }
}

%>
