<%@ taglib uri="/tld/desktopProviderContext.tld" prefix="dtpc"%>
<%@ taglib uri="/tld/desktopContainerProviderContext.tld" prefix="dtcpc"%>
<%@ taglib uri="/tld/desktop.tld" prefix="dt"%>
<%@ taglib uri="/tld/jx.tld" prefix="jx"%>
<%@ taglib uri="/tld/i18n.tld" prefix="i18n"%>
<%@ page import="
com.sun.portal.providers.containers.jsp.single.JSPSingleContainerProvider,
com.sun.portal.providers.containers.jsp.table.JSPTableContainerProvider,
com.sun.portal.providers.containers.jsp.tab.JSPTabContainerProvider,
com.sun.portal.providers.containers.jsp.menu.JSPMenuContainerProvider,
java.io.UnsupportedEncodingException,
java.net.URLEncoder,
java.util.*"
%>

<dt:obtainContainer container="$JSPProvider">

  <i18n:setBundle baseName="CommunitySamplePortal" var="CommunitySamplePortalRB"/>
  <jx:declare id="CommunitySamplePortalRB" type="java.util.ResourceBundle"/>

  <%
  String container = null;
  if ((String)request.getParameter("container") != null) {
    container = (String)request.getParameter("container");
  } else if ((String)session.getAttribute("container") != null) {
    container = (String)session.getAttribute("container");
  }


  JSPSingleContainerProvider scp = (JSPSingleContainerProvider)pageContext.getAttribute("JSPProvider");
  pageContext.setAttribute( "container", container, PageContext.REQUEST_SCOPE );
  String parentContainerProvider = scp.getProviderContext().getProviderName(container);

  JSPTableContainerProvider tcp = null;
  JSPMenuContainerProvider mcp = null;

  String containerTitle = null;
  String containerDescription = null;

  if (parentContainerProvider.equals("JSPTableContainerProvider")) {
    tcp = (JSPTableContainerProvider)scp.getContainerProviderContext().getProvider(request, scp.getName(), container);
    pageContext.setAttribute( "tableProvider", tcp,  PageContext.REQUEST_SCOPE );
    containerTitle = tcp.getStringProperty("title");
    containerDescription = tcp.getStringProperty("description");
  } else if (parentContainerProvider.equals("JSPMenuContainerProvider")) {
    mcp = (JSPMenuContainerProvider)scp.getContainerProviderContext().getProvider(request, scp.getName(), container);
    pageContext.setAttribute( "menuProvider", mcp,  PageContext.REQUEST_SCOPE );
    containerTitle = mcp.getStringProperty("title");
    containerDescription = mcp.getStringProperty("description");
  } 

  pageContext.setAttribute( "tableProvider", tcp,  PageContext.REQUEST_SCOPE );
  pageContext.setAttribute( "menuProvider", mcp,  PageContext.REQUEST_SCOPE );

  /* These are constants shared by content and process jsps and
  * refer to the state of the processing (saving) of page prefs
  */
  String COMPLETE = "complete";
  String INCOMPLETE = "incomplete";
  String ERROR = "error";

  // The params for pages
  List titles = new ArrayList();
  titles.add("content");
  titles.add("layout");

  String startPage = "content";

  /*
  * The current page can be one of the following:
  * 1. the start page
  * 2. the user clicked on another page to make it the current page
  * 3. the user is returing from saving changes via the process form and so the 
  *    current page is in the session and so it's state must be "reset".
  */
  String pagePrefsPage = startPage;
  if ((String)request.getParameter("pagePrefsPage") != null) {
    pagePrefsPage = (String)request.getParameter("pagePrefsPage");
  } else if ((String)session.getAttribute("pagePrefsPage") != null &&
    !((String)session.getAttribute("pagePrefsPage")).equals(INCOMPLETE)) {
    pagePrefsPage = (String)session.getAttribute("pagePrefsPage");
    session.setAttribute("pagePrefsPage", INCOMPLETE);
  }
  String pagePrefsPageContent = pagePrefsPage + "/" + "content.jsp";
  String contentFormValidation = pagePrefsPage + "/" + "contentFormValidation.jsp";
  %>

  <%@ include file="js/selectAll.js" %>

  <dtpc:getDesktopURL id="url"/>
  <jx:declare id="url" type="java.lang.String"/>

  <%
    url += "?provider=CommunityParentContainer&CommunityParentContainer.selectedChannel=";
    url += container;
    url = URLEncoder.encode(url, "UTF-8");
  %>

  <jsp:include page="header.jsp" flush="true">
    <jsp:param name="url" value="<%=url%>"/>
    <jsp:param name="title" value="<%=containerTitle%>"/>
    <jsp:param name="description" value="<%=containerDescription%>"/>
    <jsp:param name="incommunity" value="true"/>
  </jsp:include>

  <div id="prefscontainer"> 

    <div id="title"><%=containerTitle%> &mdash; <i18n:message key="pagepreferences" bundle="CommunitySamplePortalRB"/></div>

    <div id="tabs">

      <span id="separator-first">|</span>

      <% 
        Iterator i = titles.iterator();

        while (i.hasNext()) {

          String title = (String)i.next();
          String localizedTitle = CommunitySamplePortalRB.getString(title);

          if (title.equals(pagePrefsPage)) {
            %><span id="selected"><%=localizedTitle%></span><%
          } else {
            %><a href="<dtpc:getDesktopURL/>?provider=PagePreferencesContainer&last=false&container=<%=container%>&pagePrefsPage=<%=title%>"><%=localizedTitle%></a><%
          } 

          %><span class="separator">|</span><%

      } %> 

    </div><!-- end tabs -->

      <table cellpadding="0" cellspacing="0" width="100%" class="channel-frame">

        <tr valign="middle">

          <td class="channel-frame-title">

            <% if (pagePrefsPage.equals("content")) { %>
                <i18n:message key="change.content" bundle="CommunitySamplePortalRB"/>
            <% } else { %>
                <i18n:message key="change.layout" bundle="CommunitySamplePortalRB"/>
            <% } %> 
          </td>

          <td class="channel-frame-menu"></td>
        </tr>

      </table>

      <div class="channel-hasFrame-border">

        <%
          /*
           * This url is also the return url of the included forms process 
           * action and so given the state html about the result of the 
           * process action may get included.
           */
          String pagePrefsState = null;
          if (session.getAttribute( "pagePrefsState" ) != null &&
            !session.getAttribute( "pagePrefsState" ).equals(INCOMPLETE)) {
            pagePrefsState = (String)session.getAttribute( "pagePrefsState" );
            String pagePrefsStatePageContent = pagePrefsPage + "/" + pagePrefsState + ".jsp";
          %>

          <!-- Include info about result of pressing "Save Changes" button. -->
          <jsp:include page="<%=pagePrefsStatePageContent%>" flush="true"/>
        <% } %>

        <span class="helptext">
        <% if (pagePrefsPage.equals("content")) { %>
          <i18n:message key="change.content.help" bundle="CommunitySamplePortalRB"/>
        <% } else { %>
          <i18n:message key="change.layout.help" bundle="CommunitySamplePortalRB"/>
        <% } %>
        </span> 

        <!-- include page with javascript for client-side form validation -->
        <jsp:include page="<%=contentFormValidation%>" flush="true"/>


        <form action="<dtpc:getDesktopURL/>?provider=PagePreferencesContainer&last=false"
              target="_parent" method="POST" name="contentForm" onSubmit="selectAll()"
              enctype="application/x-www-form-urlencoded">
    
          <input type=hidden name="action" size="-1" value="process">
          <input type=hidden name="provider" size="-1" value="PagePreferencesContainer">
          <input type=hidden name="container" size="-1" value="<%=container%>">
          <input type=hidden name="pagePrefsPage" size="-1" value="<%=pagePrefsPage%>">
          <input type=hidden name="redirect" size="-1" value="<dtpc:getDesktopURL/>?provider=PagePreferencesContainer&last=false&pagePrefsPage=<%=pagePrefsPage%>&container=<%=container%>">
    
          <table cellpadding="4" cellspacing="2" border="0">
            <jsp:include page="<%=pagePrefsPageContent%>" flush="true"/>
          </table>
	     
          <div id="buttonrow">

            <input style="vertical-align: middle" class="Btn2" type="submit" name="save" id="save" value="<i18n:message key="save.changes" bundle="CommunitySamplePortalRB"/>" onMouseOver="if (this.disabled==0) this.className='Btn2Hov'" onFocus="if (this.disabled==0) this.className='Btn2Hov'" onMouseOut="if (this.disabled==0) this.className='Btn2'" onBlur="if (this.disabled==0) this.className='Btn2'" onClick="return contentFormValid();" onKeyPress="return contentFormValid();" title="<i18n:message key="save.changes.button" bundle="CommunitySamplePortalRB"/>"/>
            <input style="vertical-align: middle" class="Btn2" type="reset" name="reset" id="reset" value="<i18n:message key="reset" bundle="CommunitySamplePortalRB"/>" onMouseOver="if (this.disabled==0) this.className='Btn2Hov'" onFocus="if (this.disabled==0) this.className='Btn2Hov'" onMouseOut="if (this.disabled==0) this.className='Btn2'" onBlur="if (this.disabled==0) this.className='Btn2'" onClick="" onKeyPress="" title="<i18n:message key="reset.button" bundle="CommunitySamplePortalRB"/>"/>
            <input style="vertical-align: middle" class="Btn2" type="button" name="finished" id="finished" value="<i18n:message key="finished" bundle="CommunitySamplePortalRB"/>" onMouseOver="if (this.disabled==0) this.className='Btn2Hov'" onFocus="if (this.disabled==0) this.className='Btn2Hov'" onMouseOut="if (this.disabled==0) this.className='Btn2'" onBlur="if (this.disabled==0) this.className='Btn2'" onClick="location.href='<dtpc:getDesktopURL/>?action=content&provider=CommunityParentContainer&CommunityParentContainer.selectedChannel=<%=container%>'" onKeyPress="location.href='<dtpc:getDesktopURL/>?action=content&provider=CommunityParentContainer&CommunityParentContainer.selectedChannel=<%=container%>'" title="<i18n:message key="finished.button" bundle="CommunitySamplePortalRB"/>"/>

          </div><!-- end buttonrow -->

        </form>

      </div><!-- end channel-hasFrame-border -->

    </div><!-- end prefscontainer -->

  <%
    /* The state must be reset so the next time through the state is not the "old" state. */
    session.setAttribute("pagePrefsState", INCOMPLETE);
  %>

</dt:obtainContainer><%

%><%@ include file="footer.html"%> 
