<%--
  Copyright 2003 Sun Microsystems, Inc. All rights reserved
  Use is subject to license terms.
 --%>

<%@ page import="com.sun.ssoadapter.SSOAdapter"%>
<%@ page import="com.iplanet.sso.SSOToken"%>
<%@ page import="java.util.Map"%>
<%@ page import="java.util.HashMap"%>

<%@ taglib uri="/tld/jx.tld" prefix="jx" %>
<%@ taglib uri="/tld/desktop.tld" prefix="dt" %>
<%@ taglib uri="/tld/desktopProviderContext.tld" prefix="dtpc" %>
<%@ taglib uri="/tld/ssoadapter.tld" prefix="sso" %>
<%@ taglib uri="/tld/urlBuilder.tld" prefix="buildurl" %>
<%@ taglib uri="/tld/wireless_mail.tld" prefix="mail" %>

<dt:obtainChannel channel="$JSPProvider">
<dtpc:providerContext>
<%
	Map errorMap = new HashMap();
%><!-- SSOAdapter properties -->
<dtpc:getStringProperty key="ssoAdapter" id="ssoName"/>
<sso:adapter configname="$ssoName">
	<sso:getproperty key="enableProxyAuth" id="enableProxyAuth"/>
</sso:adapter><%
        //Normalize the string value, to take care of case differences e.g. false, FALSE, False
	String isEnableProxyAuth = (String)pageContext.getAttribute("enableProxyAuth");
        //Check for null and blank values of enableProxyAuth
        if ((isEnableProxyAuth == null) || (isEnableProxyAuth.trim().length() == 0)) {
            isEnableProxyAuth = "false";
        } else {
            isEnableProxyAuth = isEnableProxyAuth.toLowerCase();
        }
        pageContext.setAttribute("isEnableProxyAuth", isEnableProxyAuth);
%><jx:if test='$isEnableProxyAuth == "false"'>
<dt:getName id="channelName"/>
<sso:adapter configname="$ssoName" id="newSSOAdapter" channelname="$channelName">
        <dtpc:getLocalePropertiesFilters id="localeFilter"/>
	<dtpc:getCollectionProperty key="ssoEditAttributes" id="ssoEditAttributes" pfList="$localeFilter"/>
<%	%><jx:forEach var="item" items="$ssoEditAttributes"><%
			%><sso:editmapdata data="prop" id="prop" mapid="item"/><%
			%><sso:editmapdata data="type" id="type" mapid="item"/><%
	// Need to check request parameters for matching properties
			String value = request.getParameter((String)pageContext.getAttribute("prop"));
			pageContext.setAttribute("value",value);
			%>
            <jx:if test="$type != 'password'">
                <sso:setproperty key="$prop" value="$value"/>
            </jx:if>
            <jx:if test="$type == 'password'">
                <jx:if test="$value != '********'">
                    <sso:setproperty key="$prop" value="$value"/>
                </jx:if>
            </jx:if>
	 </jx:forEach>
</sso:adapter>
<%-- New SSOAdapter has been created if user modified entries --%>
<sso:adapter key="newSSOAdapter">
	<sso:getname id="newSSOName"/>
<%
	// Workaround until jx problem gets solved
	String newSSOName = (String) pageContext.getAttribute("newSSOName");
	if (newSSOName != null) {
		String ssoName = (String) pageContext.getAttribute("ssoName");
		if (! newSSOName.equals(ssoName)) {
			%><dtpc:setStringProperty key="ssoAdapter" value="$newSSOName"/><%
		} else {
			// This will init the url builder session every time a process is done.
			%><buildurl:session forceinit="true"/><%
			// This will init the mail context every time a process is done.
			%><mail:context config="${newSSOName}" reset="true" test="true"/><%
		}
	}
%></sso:adapter>
</jx:if><%



		
// Display properties 

	// Headers
	// Between zero and maxNumberHeaders attribute are ok, everything else
	// goes back with an error
%><dtpc:getIntegerProperty id="maxNumberHeaders" key="maxNumberHeaders"/><%
%><jx:declare id="maxNumberHeaders" type="Integer"/><%
	int numHeaders=10;
	try {
		numHeaders = Integer.parseInt(request.getParameter("numHeaders"));
		if ((numHeaders < 0) || (numHeaders > maxNumberHeaders.intValue())){
			errorMap.put("headerError","outOfRange");
			errorMap.put("headerValue",request.getParameter("numHeaders"));
		} else {
			pageContext.setAttribute("numHeaders",new Integer(numHeaders));
		%><dtpc:setIntegerProperty key="numberHeaders" value="$numHeaders"/><%
		}
	} catch (NumberFormatException nfee){
		// Error spouting here
		errorMap.put("headerError","NaN");
		errorMap.put("headerValue",request.getParameter("numHeaders"));
	}
        
       String dispHeadersStr = request.getParameter("displayHeaders"); 
       String dispHeaders = "false";
       if ((dispHeadersStr != null) && (dispHeadersStr.equals("displayHeaders"))){
               dispHeaders = "true";
       }
       pageContext.setAttribute("dispHeaders", dispHeaders);
       %><dtpc:setStringProperty key="displayHeaders" value="$dispHeaders"/><%

       String enableSort = request.getParameter("enableSort"); 
       String sortFlag = "false";
       if ((enableSort != null) && (enableSort.equals("sort"))){
               sortFlag = "true";
        }
        pageContext.setAttribute("sortFlag", sortFlag);
        %><dtpc:setStringProperty key="enableSort" value="$sortFlag"/><%

	// Sort order - allowed values:	DateD DateA SubA SubD FromA FromD
	// Preference sortBy can be "subject" "from" "date"
	// Preference sortDir can be "down" "up"
	// Any invalid names get ignored
	String sort = request.getParameter("sort");
	if (sort != null){
		if (sort.startsWith("Date")){
			%><dtpc:setStringProperty key="sortBy" value="date"/><%
		} else if (sort.startsWith("Sub")) {
			%><dtpc:setStringProperty key="sortBy" value="subject"/><%
		} else if (sort.startsWith("From")) {
			%><dtpc:setStringProperty key="sortBy" value="from"/><%
		}
		if (sort.endsWith("D")){
			%><dtpc:setStringProperty key="sortOrder" value="down"/><%
		} else if (sort.endsWith("A")){
			%><dtpc:setStringProperty key="sortOrder" value="up"/><%
		} 
	}
 
	// Initial Folder
	// Null and empty values get ignored
	String mailbox = request.getParameter("mailbox");
	if ((mailbox != null) && (mailbox.length()>0)){
		pageContext.setAttribute("mailbox",mailbox);
		%><dtpc:setStringProperty key="initialFolder" value="$mailbox"/><%
	}

	// Maybe dispatch to MA Mail JSP
	if (request.getParameter("MobileMail") != null) {
	      errorMap.put("targetprovider", "MAMailJSP");
	}

        if (errorMap.size() > 0){
                errorMap.put("action", "edit");
                // Encoding needed?
                errorMap.put("provider", request.getParameter("provider"));
		if (errorMap.get("targetprovider") == null)
	            errorMap.put("targetprovider", request.getParameter("targetprovider"));
                errorMap.put("containerName", request.getParameter("containerName"));
                pageContext.setAttribute("errorMap",errorMap);
%><dtpc:getDesktopURL id="url" querymap="$errorMap"/><%
        } else {
%><dtpc:getDesktopURL id="url"/><%
        }
%><jx:declare id="url" type="String"/><%
        response.sendRedirect(url);
%>
</dtpc:providerContext>
</dt:obtainChannel>
