<%--
  Copyright 2003 Sun Microsystems, Inc. All rights reserved
  Use is subject to license terms.
 --%>

<%@ page import="java.util.Map"%>
<%@ page import="java.util.HashMap"%>

<%@ taglib uri="/tld/jx.tld" prefix="jx" %>
<%@ taglib uri="/tld/desktop.tld" prefix="dt" %>
<%@ taglib uri="/tld/desktopProviderContext.tld" prefix="dtpc" %>
<%@ taglib uri="/tld/wireless_commprefs.tld" prefix="cp" %>
<%@ taglib uri="/tld/wireless_util.tld" prefix="util" %>

<util:log msg1="ENTER JSP process.jsp"/>

<dt:obtainChannel channel="$JSPProvider">
<dtpc:providerContext>
  <util:catalog resource="MAMailJSP" id="i18n"/>
  <cp:mailcontext>

<% Map redirectMap = new HashMap();
   boolean processedMain = false; %>


<%-- Process the results of the edit --%>

<%-- POP PROCESSING --%>
<% if (request.getParameter("process-pop-delete") != null) { %>

   <%@ include file="process-pop-delete.jsp" %>
 
<%} else if ("pop-add".equals(request.getParameter("process"))) { %>

   <%@ include file="process-pop-add.jsp" %>

<%} else if ("pop-edit".equals(request.getParameter("process"))) { %>

   <%@ include file="process-pop-edit.jsp" %>


<%-- RULE PROCESSING --%>
<% } else if (request.getParameter("process-rule-delete") != null) { %>

   <%@ include file="process-rule-delete.jsp" %>
   <% redirectMap.put("page", "EditRules"); %>

<%} else if ("rule-add".equals(request.getParameter("process"))) { %>

   <%@ include file="process-rule-add.jsp" %>
   <% redirectMap.put("page", "EditRules"); %>

<%} else if ("rule-edit".equals(request.getParameter("process"))) { %>

   <%@ include file="process-rule-edit.jsp" %>
   <% redirectMap.put("page", "EditRules"); %>


<%-- VIEW PROCESSING --%>
<% } else if (request.getParameter("process-view-delete") != null) { %>

   <%@ include file="process-view-delete.jsp" %>
   <% redirectMap.put("page", "EditViews"); %>

<%} else if ("view-add".equals(request.getParameter("process"))) { %>

   <%@ include file="process-view-add.jsp" %>
   <% redirectMap.put("page", "EditViews"); %>

<%} else if ("view-edit".equals(request.getParameter("process"))) { %>

   <%@ include file="process-view-edit.jsp" %>
   <% redirectMap.put("page", "EditViews"); %>


<%-- DEVICE PROCESSING --%>
<% } else if (request.getParameter("process-device") != null) { %>

   <%@ include file="process-device.jsp" %>
   <% redirectMap.put("page", "EditDevices"); %>


<%-- MAIN PROCESSING --%>
<%} else if ("main".equals(request.getParameter("process"))) { %>

   <%@ include file="process-main.jsp" %>

<% // no errors possible from process-main: exit config editing
   processedMain = true; %>   	 

<% } %>

// if there is an error key, replace it w/ error msg
<util:if name="*PAGE*" property="error">
  <util:msg name="i18n" key="${*PAGE*:error}" default="" id="error"/>
</util:if>
<util:log msg1="ERRMSG=" msg2="${*PAGE*:error}"/>

<%-- Setup the next edit page, and invoke the redirect --%>

<%
   // Error Processing
   if (pageContext.getAttribute("error") != null) { 
      redirectMap.put("error", pageContext.getAttribute("error"));
   }

   redirectMap.put("action", "edit");
   redirectMap.put("provider", request.getParameter("provider"));
   redirectMap.put("targetprovider", request.getParameter("targetprovider"));
   redirectMap.put("containerName", request.getParameter("containerName"));

   // continue editing in sub-pages, if page not already set
   if (redirectMap.get("page") == null) {
     if (request.getParameter("OpenAddPop") != null) {
       redirectMap.put("page", "EditPop");
       redirectMap.put("mode", "add");
     } else if (request.getParameter("OpenEditPop") != null) {
       redirectMap.put("page", "EditPop");
       redirectMap.put("mode", "edit");

     } else if (request.getParameter("OpenRules") != null) {
       redirectMap.put("page", "EditRules");
     } else if (request.getParameter("OpenAddRule") != null) {
       redirectMap.put("page", "EditRule");
       redirectMap.put("mode", "add");
     } else if (request.getParameter("OpenEditRule") != null) {
       redirectMap.put("page", "EditRule");
       redirectMap.put("mode", "edit");

     } else if (request.getParameter("OpenViews") != null) {
       redirectMap.put("page", "EditViews");
     } else if (request.getParameter("OpenAddView") != null) {
       redirectMap.put("page", "EditView");
       redirectMap.put("mode", "add");
     } else if (request.getParameter("OpenEditView") != null) {
       redirectMap.put("page", "EditView");
       redirectMap.put("mode", "edit");

     } else if (request.getParameter("OpenDevices") != null) {
       redirectMap.put("page", "EditDevices");
     } else if (request.getParameter("OpenDevice") != null) {
       if (request.getParameter("client") != null) {
	  redirectMap.put("client", request.getParameter("client"));
       }
       redirectMap.put("page", "EditDevice");
     };
   }
   if (request.getParameter("name") != null) {
      redirectMap.put("name", request.getParameter("name"));
   }

   // if done editing (processed main succesfully, after 'Finished' 
   // button pressed on main screen), exit (don't redirect)
   if (! ((redirectMap.get("page") == null) && processedMain)) {

   pageContext.setAttribute("redirectMap",redirectMap);

%><dtpc:getDesktopURL id="url" querymap="$redirectMap"/><%
%><jx:declare id="url" type="String"/><%
  response.sendRedirect(url);
%>
  
<% } %>

</cp:mailcontext>
</dtpc:providerContext>
</dt:obtainChannel>

<util:log msg1="EXIT JSP process.jsp"/>
