<%-- 
  Copyright 2001 Sun Microsystems, Inc.  All rights reserved. 
  PROPRIETARY/CONFIDENTIAL.  Use of this product is subject to license terms. 
--%>

<%@ page import="com.sun.portal.wireless.providers.rendering.wrapping.RenderingWrappingProvider"%>
<%@ page import="com.sun.portal.wireless.providers.containers.rendering.RenderingContainerProvider"%>
<%@ page import="com.sun.portal.providers.context.ContainerProviderContext"%>
<%@ page import="com.sun.portal.providers.containers.ContainerProvider"%>
<%@ page import="com.sun.portal.desktop.RequestThreadLocalizer"%>
<%@ page import="com.sun.portal.providers.Provider"%>
<%@ page import="com.iplanet.am.util.Debug"%>
<%@ page import="javax.servlet.http.HttpServletResponse"%>
<%@ page import="java.net.URI"%>



<%@ page session="false" %>

<%

  // Get the container
  RenderingWrappingProvider rwp = (RenderingWrappingProvider)pageContext.getAttribute("JSPProvider");
  StringBuffer sb = rwp.getWrappedChannelContent(request, response);
  ContainerProviderContext cpc = 
            (ContainerProviderContext) rwp.getProviderContext();
  String wrappedChannel = rwp.getStringProperty("wrappedChannel");
  Provider p = cpc.getProvider(
                 RequestThreadLocalizer.getRequest(), null, wrappedChannel);
  String providerClassName = p.getClass().getName();

  /**
   *   Some channels(links to channels) are launched directly from the mobile 
   *   home page like Mail, calendar , AB. The list below specifies the
   *   providers pertaining to those channels.
   *   The display.template pertaining to those providers contains
   *   only TAGS(NOT AmlDocument or WMLDocument) which refer to the URL to be 
   *   redirected when the link to the   channel is clicked.
   *   Other channels(links to channels) like BooksMarks, user Information etc.
   *   have  display.template which are typically an AML document/WML document.
   *   These documents contain tags which refer to the URL (which user will 
   *   click ) 
   *   The providers having these kind of display.template cannot be launched
   *   /redirected directly. Here is the logic to distinguish between those 
   *   two types of providers.
   */

  String[] redirectToProviders = { 
                       "com.sun.portal.providers.mail.MailProvider", 
                       "com.sun.portal.providers.calendar.CalendarProvider", 
                       "com.sun.portal.providers.ab.AddressBookProvider"
                     };

  boolean canRedirect=false;
  for(int i=0;i<redirectToProviders.length;++i) {
      if(redirectToProviders[i].equals(providerClassName)) 
      { 

          /**
           * Creation of URI object is to verify whether it is an
           * valid URI so that it can be redirected.
           * On error conditions sb.toString() returns the contents 
           * from display-error.template which will be an error message
           * in the AML or WML template form. In such cases it should not be 
           * redirected.
           */

          try {
              URI u = URI.create(sb.toString().trim());
          } catch(IllegalArgumentException e) {
              break;
          }
          canRedirect = true;
          break;
      }
  }
  
  if(canRedirect) {

      /**
       *  when the compression is not enabled, the URL to be redirected contains
       *  "&amp;" string which needs to be replaced with "&". 
       */

      int index=0;
      String stringToBeReplaced = "&amp;";
      String replaceWithString="&";
      while((index=sb.indexOf(stringToBeReplaced)) != -1) {

          sb = sb.replace(
                  index,index+stringToBeReplaced.length(),replaceWithString);
      }
      HttpServletResponse res_orig = RequestThreadLocalizer.getResponse();
      response.setStatus(response.SC_OK);
      res_orig.sendRedirect(sb.toString());
      try {
          try {
              PrintWriter pw = res_orig.getWriter();
              pw.close();
          } catch(IllegalStateException ise) {
              ServletOutputStream sos = res_orig.getOutputStream();
              sos.close();
          }
      } catch(Throwable t) {
          StackTraceElement elem[] = t.getStackTrace();
          Debug debug = Debug.getInstance("mapJsp");
          for(int i=0;i<elem.length;i++) {
              debug.error(elem[i].toString());
          }
      }
      return;
  } 
  String parent = cpc.getParentContainerName(rwp.getName());
  String filepath = cpc.getClientPath();
  if(parent != null){
      ContainerProvider cp = (ContainerProvider)cpc.
          getProvider(request, null, parent);
      if(cp instanceof RenderingContainerProvider){
          if(!filepath.startsWith("aml") &&
             !filepath.startsWith("/aml") ) {
              // Parent is Rendering Container and file path does 
              // not start with 'aml'
              // Wrap content with <AmlContainer> .. return AML
              sb.insert (0, "<AmlContainer>");
              sb.append ("</AmlContainer> ");
          } 
	  }
  }
  if(sb == null) sb=new StringBuffer("");
  out.println(sb);
%>
