<%@ include file="contentSetup.jsp" %>

<dt:obtainContainer container="$wireless"> 
  <dtpc:getCollectionProperty id="channelsIsRemovable" key="channelsIsRemovable"/>  
  <dtpc:getBooleanProperty id="defaultIsRemovable" key="defaultChannelIsRemovable"/>
  <jx:declare id="channelsIsRemovable" type="Map"/>
  <jx:declare id="defaultIsRemovable" type="Boolean"/>

  <%-- Some preparation specific to generate the content list --%>
  <%
    // Construct a new available list adjusted for removable channels
    StringBuffer selectedChannelsBuf   = new StringBuffer();
    ArrayList    adjustedAvailableList = new ArrayList();
    int          numAvailableChannels  = availableChannels.size();

    for (int i=0; i<numAvailableChannels; i++) {
      // Is this channel removable?
      String  channelName      = (String)availableChannels.get(i);
      Boolean isRemovableFlag  = defaultIsRemovable;
      Object isRemovableValue  = channelsIsRemovable.get(channelName);

      if (isRemovableValue != null) {
        isRemovableFlag = ((Boolean)isRemovableValue);
      } 

      if (isRemovableFlag.booleanValue()) {
        // We have a removable channel
        adjustedAvailableList.add(channelName);
      } 
    }

    pageContext.setAttribute("adjustedAvailableChannels", adjustedAvailableList);
  %>

<%-- The presentation of content edit page --%>

<html>
  <head>
    <title>Content</title>
  </head>
  <body>
    <b>Display Channels:</b><br>
    <form method=post action="<%=desktopURL%>">
      <input type=hidden name="action" value="process">
      <input type=hidden name="provider" value="WirelessJSPContentChannel">
      <input type=hidden name="container" value="<%=container%>">

      <jx:forEach var="channel" items="$adjustedAvailableChannels">
        <jx:declare id="channel" type="java.lang.String"/>
        <dtcpc:obtainChannelFromContainer channel="$channel">
          <%
            String checked = "";
            if (selectedChannels.contains(channel)) {
              checked="CHECKED";
            }
          %>
          <input type=checkbox name="content" value="<dt:getName/>" <%=checked%>><dt:getTitle/></input><br>
        </dtcpc:obtainChannelFromContainer>
      </jx:forEach>
      <input type=submit value="Done">
    </form>
  </body>
</html>

</dt:obtainContainer>