<%-- 
  Copyright 2003 Sun Microsystems, Inc. All rights reserved 
  Use is subject to license terms.
 --%>
<%-- table.jsp --%>

<%@ taglib uri="/tld/desktopTable.tld" prefix="dttable" %>
<%@ taglib uri="/tld/desktopTab.tld" prefix="tab" %>
<%@ taglib uri="/tld/desktopProviderContext.tld" prefix="dtpc" %>
<%@ taglib uri="/tld/desktopContainerProviderContext.tld" prefix="dtcpc" %>
<%@ taglib uri="/tld/desktop.tld" prefix="dt" %>
<%@ taglib uri="/tld/desktopTheme.tld" prefix="dttheme" %>
<%@ taglib uri="/tld/jx.tld" prefix="jx" %>
<%@ taglib uri="/tld/i18n.tld" prefix="i18n" %>


<%@ page import="java.util.Enumeration"%>
<%@ page import="java.util.List"%>
<%@ page import="java.util.Map"%>
<%@ page import="com.sun.portal.providers.containers.jsp.tab.UnmodifiableTab"%>
<%@ page import="com.sun.portal.providers.containers.jsp.table.JSPTableContainerProvider,
                 com.sun.portal.providers.context.ProviderContext" %>


<%@ page session="false" %>

<dt:obtainContainer container="$JSPProvider">
  <dttable:tableContainerProvider>
    <i18n:setBundle baseName="JSPTableContainerProviderAnonymousJSP" var="jsptablecontainerprovideranonymousjsp" />
    <dtpc:getStringProperty key="fontFace1" id="fontFace1" scope="request"/>
    <dtpc:getCollectionProperty key="borderlessChannels" id="borderlessChannels" scope="request"/>
      <dt:getName id="containerName" scope="request"/>
<%
       JSPTableContainerProvider tcp = (JSPTableContainerProvider)pageContext.getAttribute("JSPProvider");
       ProviderContext pc = tcp.getProviderContext();
       String fontFace1 = (String)pageContext.getAttribute("fontFace1",PageContext.REQUEST_SCOPE);
       String containerName = (String)pageContext.getAttribute("containerName", PageContext.REQUEST_SCOPE);
       UnmodifiableTab tab = (UnmodifiableTab)pageContext.getAttribute("selectedTab",PageContext.REQUEST_SCOPE);
       String selectedTabName = (String)tab.getDisplayname();
       Map borderlessChannels = (Map)pageContext.getAttribute("borderlessChannels", PageContext.REQUEST_SCOPE);
       StringBuffer paramsb = new StringBuffer("");
       for (Enumeration params = request.getParameterNames(); params.hasMoreElements();) {
          String param = (String)params.nextElement();
          String value = request.getParameter(param);
		  paramsb.append("&")
		      .append(param)
		      .append("=")
		      .append(pc.encodeURLParameter(value));  
		  }
%>

<jsp:include page="toolbarRollovers.js" flush="true"/>

<!--begin toolbar -->

<table border="0" cellpadding="0" cellspacing="0" width="100%">
    <tr>
      <td bgcolor="<dttheme:getAttribute name="titleBarColor" default="#9999CC"/>"><img src="<dt:scontent/>/desktop/images/nothing.gif" width="1" height="3" alt=""></td>
    </tr>
    
</table>

<!--end toolbar -->

      <dt:getSelectedChannels id="selectedChannel"/>  
<% pageContext.setAttribute( "hasChannel", new Boolean( ((List)pageContext.getAttribute( "selectedChannel" )).size()>0)); %>

<dtpc:getProviderVersion id="version" scope="request"/>
<jx:if test="$version > 1">
   <dtpc:getStringProperty key="maximizedChannel" id="maximizedChannel" scope="request"/>
</jx:if>
<%
    String maximizedChannel = "";
    int version = ((Integer)pageContext.getAttribute("version", PageContext.REQUEST_SCOPE)).intValue();
    if (version > 1) {
        maximizedChannel = (String)pageContext.getAttribute("maximizedChannel",PageContext.REQUEST_SCOPE);
    }
    List selectedChannels = (List)pageContext.getAttribute("selectedChannel");
    if (!selectedChannels.contains(maximizedChannel)) {
        maximizedChannel = "";
        pageContext.setAttribute("maximizedChannel", maximizedChannel);
    }
     Boolean hasMaximizedChannel = new Boolean(maximizedChannel != null && maximizedChannel.length() != 0);
     pageContext.setAttribute( "hasMaximizedChannel", hasMaximizedChannel);
%>
<dttable:getContent id="contentMap" scope="request"/>

<TABLE WIDTH=100% BORDER=0 CELLPADDING=5 CELLSPACING=0>
<TR><TD BGCOLOR="<dttheme:getAttribute name="tableBgColor" default="#333366"/>">

        <jx:choose>
        <jx:when test="$hasChannel == 'false'">

             <i18n:message key="noProviderIsAvailable" bundle="jsptablecontainerprovideranonymousjsp" />

        </jx:when>
        <jx:when test="$hasMaximizedChannel == true">
            <jsp:include page="tablemaximized.jsp" flush="true"/>
        </jx:when>

        <jx:otherwise>

<!-- BEGIN FULL  TOP CHANNELS -->
<dttable:getColumns id="channels" column="top" scope="request"/>
<jsp:include page="tabletopbottom.jsp" flush="true"/>
<!-- END TOP CHANNELS -->

<TABLE WIDTH=100% BORDER=0 CELLPADDING=0 CELLSPACING=4>
<TR>
<!-- BEGIN LEFT CHANNELS -->
<dttable:getColumns id="channels" column="left" scope="request"/>
<jsp:include page="tablecolumn.jsp" flush="true">
  <jsp:param name="columnName" value="left"/>
</jsp:include>
<!-- END LEFT CHANNELS -->

<!-- BEGIN CENTER CHANNELS -->
<dttable:getColumns id="channels" column="center" scope="request"/>
<jsp:include page="tablecolumn.jsp" flush="true">
  <jsp:param name="columnName" value="center"/>
</jsp:include>
<!-- END CENTER CHANNELS -->

<!-- BEGIN RIGHT CHANNELS -->
<dttable:getColumns id="channels" column="right" scope="request"/>
<jsp:include page="tablecolumn.jsp" flush="true">
  <jsp:param name="columnName" value="right"/>
</jsp:include>
<!-- END RIGHT CHANNELS -->

</TR></TABLE>
<!-- BEGIN FULL BOTTOM CHANNELS -->
<dttable:getColumns id="channels" column="bottom" scope="request"/>
<jsp:include page="tabletopbottom.jsp" flush="true"/>
<!-- END BOTTOM CHANNELS -->
</jx:otherwise>
</jx:choose>
  </dttable:tableContainerProvider>
</dt:obtainContainer>

</TD></TR>

</TABLE>

