<%--
  Copyright 2004 Sun Microsystems, Inc. All rights reserved
  Use is subject to license terms.
 --%>
<%-- arrangeChannels.jsp --%>

<%@ page import="java.util.List,
                 java.util.Map,
                 java.util.Set,
                 java.util.ArrayList,
		 com.sun.portal.providers.context.ProviderContext,
                 com.sun.portal.providers.jsp.JSPProvider"
%>

<%@ page session="false" %>

<%@ taglib uri="/tld/desktopProviderContext.tld" prefix="dtpc" %>
<%@ taglib uri="/tld/desktop.tld" prefix="dt" %>
<%@ taglib uri="/tld/desktopTheme.tld" prefix="dttheme" %>
<%@ taglib uri="/tld/jx.tld" prefix="jx" %>
<%@ taglib uri="/tld/channeltaskadmin.tld" prefix="dtadmin" %>
<%@ taglib uri="/tld/i18n.tld" prefix="i18n" %>
<dt:obtainChannel channel="$JSPProvider">
<i18n:setBundle baseName="TaskAdminTabConfiguratorJSP" var="taskadmintabconfiguratorjsp" />

<%@ include file="arrangeProvider.js" %>
<%@ include file="performSubstitution.js" %>
<%@ include file="performColumnSubstitution.js" %>
<%@ include file="selectAll.js" %>
<%@ include file="switchColumns.js" %>
<%@ include file="detectCheckedRadioButton.js" %>

<%!
       List leftChannels = null;
       List rightChannels = null;
       List thickChannels = null;
       List topChannels = null;
       List bottomChannels = null;
%> 

<dt:getName id="adminChannelName"/>
<jx:declare id="adminChannelName" type="java.lang.String"/>
<dtpc:getStringProperty key="fontFace1" id="fontFace1" scope="request"/>
<jx:declare id="fontFace1" type="java.lang.String"/>
<dtpc:getStringProperty key="roleDN" id="roleDN"/>
<jx:declare id="roleDN" type="java.lang.String"/>
<%
       String container = request.getParameter(adminChannelName + ".containerName");
       pageContext.setAttribute("container", container);
	JSPProvider jp = (JSPProvider)pageContext.getAttribute("JSPProvider");
ProviderContext pc = jp.getProviderContext();
List pflist = pc.getLocalePropertiesFilters();
pageContext.setAttribute("pflist", pflist);
%>

<dtadmin:obtainChannelAdmin baseDN="$roleDN">
<%-- get the list of selected channels --%>
<dtadmin:getSelectedChannels id="selected" container="$container"/>
<%-- get the layout for this container --%>
<dtadmin:getIntegerProperty id="layout" key="layout" channel="$container"/>
<jx:declare id="layout" type="java.lang.Integer"/>
<dtadmin:getMapProperty id="channelsColumn" key="channelsColumn" channel="$container"/>
<jx:declare id="channelsColumn" type="java.util.Map"/>
<dtadmin:getStringProperty key="title" id="title" channel="$container" pflist="$pflist"/>
<jx:declare id="title" type="java.lang.String"/>

<% 
       leftChannels = new ArrayList();
       rightChannels = new ArrayList();
       thickChannels = new ArrayList();
       topChannels = new ArrayList();
       bottomChannels = new ArrayList();
%>

<jx:forEach var="channel" items="$selected">
<jx:declare id="channel" type="java.lang.String"/>

<dtadmin:getPropertyNames id="propertiesSet" channel="$channel" regExp="width"/>
<% Set set = (Set)pageContext.getAttribute("propertiesSet");
	if(set.contains("width")) { %>
	<dtadmin:getStringProperty id="width" key="width" channel="$channel"/>
<%	} else {
	pageContext.setAttribute("width", "thin");
	}
%>

<jx:choose>
<jx:when test="$width == 'thin'">
<% leftChannels.add(channel);%>
</jx:when>
<jx:when test="$width == 'thick'">
<% thickChannels.add(channel);%>
</jx:when>
<jx:when test="$width == 'full_top'">
<% topChannels.add(channel);%>
</jx:when>
<jx:when test="$width == 'full_bottom'">
<% bottomChannels.add(channel);%>
</jx:when>
</jx:choose>
</jx:forEach>
    <jx:set var="topSize">
    <%=topChannels.size()%>
    </jx:set>
    <jx:set var="bottomSize">
    <%=bottomChannels.size()%>
    </jx:set>
<dtadmin:getMapProperty channel="$container" key="channelsRow" id="channelsRow"/>
<%
boolean havetoporbottom = topChannels.size() != 0 || bottomChannels.size() != 0;
pageContext.setAttribute("havetoporbottom", new Boolean(havetoporbottom));
pageContext.setAttribute("leftChannels", leftChannels);
Map channelsRowMap = (Map)pageContext.getAttribute("channelsRow");
if(channelsRowMap == null || channelsRowMap.size() == 0) {
	pageContext.setAttribute("thickChannels", thickChannels);
	pageContext.setAttribute("topChannels", topChannels);
	pageContext.setAttribute("bottomChannels", bottomChannels);
} else {
	pageContext.setAttribute("thickChannels", getOrderedChannels(channelsRowMap, thickChannels));
	pageContext.setAttribute("topChannels", getOrderedChannels(channelsRowMap, topChannels));
	pageContext.setAttribute("bottomChannels", getOrderedChannels(channelsRowMap, bottomChannels));
}
%>	 
<%
   String layoutOneChecked = "";
   String layoutTwoChecked = "";
   String layoutThreeChecked = "";
%>
        <jx:choose>
          <jx:when test="$layout == 1">
<%
            layoutOneChecked = "selected";
%>
          </jx:when>
          <jx:when test="$layout == 2">
<%
            layoutTwoChecked = "selected";
%>
          </jx:when>
          <jx:when test="$layout == 3">
<%
            layoutThreeChecked = "selected";
%>
          <jx:forEach var="channel" items="$leftChannels">
          <jx:declare id="channel" type="java.lang.String"/>
<%
            String columnstr = "1";
            if (channelsColumn.containsKey(channel)) {
                columnstr = (String)channelsColumn.get(channel);
            }
            int column = Integer.parseInt(columnstr);
            if (column != 1) {
                 rightChannels.add(channel);
            }
%>
          </jx:forEach>
          <%
            pageContext.setAttribute("rightChannels", rightChannels);
            leftChannels.removeAll(rightChannels);
          %>
          </jx:when>
        </jx:choose>
<center>
<%
if(channelsRowMap == null || channelsRowMap.size() == 0) {
	pageContext.setAttribute("leftChannels", leftChannels);
	pageContext.setAttribute("rightChannels", rightChannels);	
} else {
	pageContext.setAttribute("leftChannels", getOrderedChannels(channelsRowMap, leftChannels));
	pageContext.setAttribute("rightChannels", getOrderedChannels(channelsRowMap, rightChannels));
}

%>

<form action="<dtpc:getDesktopURL/>" TARGET="_parent" method="POST" name="layoutForm" onSubmit="selectAll()" enctype="application/x-www-form-urlencoded" >
<input type=HIDDEN name="action" size=-1 value="process">
<input type=HIDDEN name="provider" size=-1 value="<dt:getName/>">
<input type=HIDDEN name="<dt:getName/>.containerName" size=-1 value="<%=container%>">
<input type=HIDDEN name="<dt:getName/>.page" size="-1" value="arrangeChannels">
<input type=HIDDEN name="temp1" value="">
<input type=HIDDEN name="temp2" value="">
<input type=HIDDEN name="temp3" value="">

<table border=0 cellpadding=2 cellspacing=0 width="100%">
	<tr>
		<td nowrap width="15%" align="justify" bgcolor="<dttheme:getAttribute name="tabColor" default="#CCCCCC"/>">
		<font color="<dttheme:getAttribute name="tabFontColor" default="#000000"/>" size="-1" face="Verdana">
		<b><i18n:message key="selectlayoutfortab" bundle="taskadmintabconfiguratorjsp" /> </b></font></td>
		<td>
		<font size="-1" face="Verdana">
		<b><%=title%></b>		
		</td>		
	<tr>					
      <tr>
        <td colspan="2">&nbsp;</td>
      </tr>
      <tr>
        <td colspan="2"><%@ include file="selectLayout.jsp" %></td>
      </tr>
      <tr>
        <td colspan="2">
          <p>
            <%@ include file="layout.jsp" %>
<br>
            <br>

            <center>
              <font face="<%=fontFace1%>">
              <input type=SUBMIT name="Submit" value="<i18n:message key="finished" bundle="taskadmintabconfiguratorjsp" />"  style='background-color:<dttheme:getAttribute name="titleBarColor" default="#333366"/>;color:<dttheme:getAttribute name="titleFontColor" default="#FFFFFF"/>'>
              <input type=BUTTON onClick="top.document.location.href='<dtpc:getDesktopURL/>'" value="<i18n:message key="cancel" bundle="taskadmintabconfiguratorjsp" />"  style='background-color:<dttheme:getAttribute name="titleBarColor" default="#333366"/>;color:<dttheme:getAttribute name="titleFontColor" default="#FFFFFF"/>'>
              </font>
            </center>
        </td>
      </tr>
    </table>
</form>
<script language="javascript">setCheckedValue()</script>
</CENTER>

</dtadmin:obtainChannelAdmin>
</dt:obtainChannel>

<%!
	private List getOrderedChannels(Map map, List unorderedChannelList) {
		String[] orderedChannelAtrray = new String[unorderedChannelList.size()];
		ArrayList orderedChannelList = new ArrayList();		
		try {
			for(int i = 0; i < unorderedChannelList.size(); i++) {
				String indexStr = (String)map.get(unorderedChannelList.get(i));
				int channelIndex = Integer.parseInt(indexStr);
				orderedChannelAtrray[channelIndex - 1] = (String)unorderedChannelList.get(i);
			}
			for(int j = 0; j < orderedChannelAtrray.length; j++) {
				orderedChannelList.add(orderedChannelAtrray[j]);
			}
		} catch(Exception e) {
			return unorderedChannelList;
		} 
		return orderedChannelList;
	}
%>
