<%@ taglib uri="/tld/desktop.tld" prefix="dt"
%><%@ taglib uri="/tld/desktopProviderContext.tld" prefix="dtpc"
%><%@ taglib uri="/tld/jx.tld" prefix="jx"
%><%@ page import="
java.io.*,
java.net.*,
java.util.*,
com.iplanet.sso.*,
com.iplanet.am.sdk.*,
com.iplanet.am.util.*,
com.sun.identity.security.AdminTokenAction,
java.security.AccessController"%>

<%!
// This JSP is responsible for displaying the search results based on the
// search criteria for finding an employee within an organization.
//
AMStoreConnection amsc = null;

/*
 * Responsible for obtaining a connection to the Sun Java System
 * Identity Server data store.	The connection is established with
 * the admin credentials.
 *
 * @return AMStoreConnection
 * @throws Exception
 */
public AMStoreConnection getAdminConnection() throws Exception {
    SSOTokenManager ssom = SSOTokenManager.getInstance();
    SSOToken adminToken =
        (SSOToken)AccessController.doPrivileged(AdminTokenAction.getInstance());
  return new AMStoreConnection(adminToken);
}

public String getStringAttribute(AMUser amUser, String attributeName) throws Exception {
  return (amUser.getStringAttribute(attributeName) == null) ? 
    "" : amUser.getStringAttribute(attributeName);
}

public Map addUser(AMUser amUser, Map members, String[] userAttributeKeys) throws Exception {
  String sn = getStringAttribute(amUser,"sn");
  String givenname = getStringAttribute(amUser,"givenname");
  String uid = amUser.getStringAttribute("uid");
  String key = sn + "_" + givenname + "_" + uid;
  if (!members.containsKey(key)) {
    Hashtable data = new Hashtable();
    int len = userAttributeKeys.length;
    for (int i=0; i<len; i++) {
      String userAttributeKey = userAttributeKeys[i];
      data.put(userAttributeKey,getStringAttribute(amUser,userAttributeKey));
    }
    members.put(key,data);
  }
  return members;
}

public String getOrganizationDN(HttpServletRequest request) throws Exception {
    SSOTokenManager ssomanager = SSOTokenManager.getInstance();
    SSOToken userToken = ssomanager.createSSOToken(request);
    AMStoreConnection amconn = new AMStoreConnection(userToken);

    String userPrincipal  = userToken.getPrincipal().getName();
    String organizationDN = null;

    if ((amconn != null) && (amconn.isValidEntry(userPrincipal))) {
        AMUser user = amconn.getUser(userPrincipal);
        organizationDN = user.getOrganizationDN();
    }

    return organizationDN;
}
%>


<dt:obtainChannel channel="$JSPProvider">
<dtpc:providerContext>
<dtpc:getCollectionProperty key="projects" id="projects"/>
<jx:declare id="projects" type="Map"/>   
<dtpc:getUserID id="userID"/>
<jx:declare id="userID" type="String"/>

<%
// main - entry point
String project= null;
if ((String)request.getParameter("project") != null) {
  project= (String)request.getParameter("project");
} else {
  Iterator itr = projects.keySet().iterator();
  project =(String)itr.next();
}

Map projectMap =(Map)projects.get(project);
Map members = Collections.synchronizedMap(new TreeMap());

// check for AMStoreConnection
//
if (amsc == null) {
  amsc = getAdminConnection();
}

String[] userAttributeKeys = {
"uid", "sn", "givenname", "cn", "mail", "postaladdress", "telephonenumber" 
};

String organizationDN = getOrganizationDN(request);

if (amsc != null) {
  String roles =(String)projectMap.get("roles");
  if (roles != null && !roles.equals("")) {
    StringTokenizer st = new StringTokenizer(roles,",");
    while (st.hasMoreTokens()) {
      String role = st.nextToken();
      String roleDN = amsc.getRoleNamingAttribute() + "=" + role + "," + organizationDN;
      if (amsc.isValidEntry(roleDN)) {
        AMRole amRole = amsc.getRole(roleDN);
        Set userDNs = amRole.getUserDNs();
        if (userDNs != null) {
          Iterator itr = userDNs.iterator();
          while (itr.hasNext()) {
            String userDN = (String)itr.next();
            if (amsc.isValidEntry(userDN)) {
              AMUser amUser = amsc.getUser(userDN);
              if (amUser != null) {
                members = addUser(amUser, members, userAttributeKeys);
              }
            }
          }
        }
      }
    }
  } else {
    // no roles defined, just show current user
    members = addUser(amsc.getUser(userID), members, userAttributeKeys);
  }
}
%>

<%
if (members != null && members.size() > 0) {
	%>
  <table cellpadding="0" cellspacing="0" border="0" width="100%">
	<%
	Iterator mitr = members.keySet().iterator();
	int cnt = members.size();
	while (mitr.hasNext()) {
		String memberKey = (String)mitr.next();
		Hashtable memberData = (Hashtable)members.get(memberKey);
		%>
    <tr valign="bottom"><td nowrap>Name:&nbsp;</td><td nowrap><%=memberData.get("cn")%></td></tr>
    <tr valign="bottom"><td nowrap>Email:&nbsp;</td><td nowrap><a href="mailto:<%=memberData.get("mail")%>"><%=memberData.get("mail")%></a></td></tr>
    <tr valign="bottom"><td nowrap>Phone:&nbsp;</td><td nowrap><%=memberData.get("telephonenumber")%></td></tr>
		<%
		cnt--;
		if (cnt > 0) {
		%><tr valign="bottom"><td>&nbsp;</td</tr><%
		}
	}
	%>
	</table>
	<%
}
%>
 
</dtpc:providerContext>
</dt:obtainChannel>
