/**
 * $Id: util.js,v 1.3 2005/08/19 18:29:28 js143762 Exp $
 * Copyright  2003 Sun Microsystems, Inc. All rights reserved.
 *
 * U.S. Government Rights - Commercial software. Government users
 * are subject to the Sun Microsystems, Inc. standard license
 * agreement and applicable provisions of the FAR and its
 * supplements.
 *
 * Use is subject to license terms.
 *
 * This distribution may include materials developed by third
 * parties.Sun, Sun Microsystems, the Sun logo and Java are
 * trademarks or registered trademarks of Sun Microsystems, Inc.
 * in the U.S. and other countries.
 *
 * Copyright  2003 Sun Microsystems, Inc. Tous droits rservs.
 *
 * L'utilisation est soumise aux termes du contrat de licence.
 *
 * Cette distribution peut comprendre des composants dvelopps
 * par des tierces parties.
 *
 * Sun, Sun Microsystems, le logo Sun et Java sont des marques de
 * fabrique ou des marques dposes de Sun Microsystems, Inc. aux
 * Etats-Unis et dans d'autres pays.
 */

/** open the help window */
function openWindow(url,windowName) {
    windowName = window.open(url,windowName,'scrollbars,resizable,width=650,height=500,top='+((screen.height - (screen.height/1.618))-(500/2))+',left='+((screen.width-650)/2));
    windowName.focus();
}
/** close the help window */
function closeHelpWindow(windowName) {
	windowName.close();
}

/** makes current page occupies entire browser window */
function occupyFullBrowser() {
    if (top.location != window.location) {
	top.location = window.location;
    }
}

/** places cursor on the first form element */
function placeCursorOnFirstElm() {
    var frms = document.forms;
    var frmCount = frms.length;

    for (var i = 0; i < frmCount; i++) {
	var frm = frms[i];
	var sz = frm.elements.length;

	for (var j = 0; j < sz; j++) {
	    var elm = frm.elements[j];

	    if (elm.type != "hidden") {
		elm.focus();
		return;
	    }
	}
    }
}

/** 
 * writes the corresponding css based on browser type 
 *
 * @param uri
 *
 */
function writeCSS(uri) {
	var css = null
	if (is_ie5up) {
		css = uri + '/css/css_ie5win.css';
	} else if (is_gecko) {
		css = uri + '/css/css_ns6up.css';
		if (is_linux) {
			css = uri + '/css/css_linuxns6up.css';
		}
	}
	if (css != null) {
		document.write("<link href='" + css + "' type='text/css' rel='stylesheet'>");
  } else {
		javascript:alert('This browser is not currently supported.')
	}
}

/**
 * marks button
 *
 * @param label of button
 * @param href of button
 */
function markupButton(label, href) {
    label = "&nbsp;" + strTrim(label) + "&nbsp;";
    document.write("<table border=\"0\" cellpadding=\"1\" cellspacing=\"0\"");
    document.write(" class=\"button-frame-enabled\">");
    document.write("<tr><td>");
    document.write("<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"");
    document.write(" class=\"button-content-enabled\">");
    document.write("<tr><td align=\"center\" valign=\"middle\" nowrap>");
    document.write("<div class=\"button-link-enabled-text\"><a href=\"");
    document.write(href);
    document.write("\" class=\"button-link\">");
    document.write(label);
    document.write("</a></div></td></tr></table>");
    document.write("</td></tr></table>");
}

/**
 * aggregrates all the form elements in different forms into
 * a hidden form
 */
function aggSubmit() {
    var frms = document.forms;
    var hiddenFrm = frms['Login'];

    if (hiddenFrm != null) {
	for (var i = 0; i < elmCount; i++) {
	    var frm = frms['frm' + i];

	    if (frm != null) {
		var elm = frm.elements[0];

		if (elm != null) {
		    if (elm.type == 'radio') {
			hiddenFrm.elements[i].value =
			    getSelectedRadioValue(frm);
		    } else if (elm.type == 'checkbox') {
			hiddenFrm.elements[i].value = 
                            getSelectedCheckBoxValues(frm);
		    } else {
			hiddenFrm.elements[i].value = elm.value;
		    }
		}
	    }
	}
    }
}

/**
 * gets selected radio value
 *
 * @param frmObj - form object
 */
function getSelectedRadioValue(frmObj) {
    for (var i = 0; i < frmObj.elements.length; i++) {
	var elm = frmObj.elements[i];

	if (elm.checked) {
	    return elm.value;
	}
    }
    return "";
}

/**
 * gets selected check box values separated by "|"
 *
 * @param frmObj - form object
 */
function getSelectedCheckBoxValues(frmObj) {
    var checked = "";
    for (var i = 0; i < frmObj.elements.length; i++) {
	var elm = frmObj.elements[i];

        if ((elm.checked) && (elm.type == 'checkbox')) {
            checked = checked + elm.value + "|";
        }
    }
    return checked;
}

/**
 * trims leading and trailing spaces of a string
 *
 * @param str - string to trim
 * @return trimmed string
 */
function strTrim(str){
    return str.replace(/^\s+/,'').replace(/\s+$/,'')
}

/**
 * clears all form elements
 *
 * @param frm - form obj
 */
function clearFormElms(frm) {
    if (frm != null) {
	var elms = frm.elements;

	if ((elms != null) && (elms.length > 0)) {
	    for (var i = 0; i < elms.length; i++) {
		var elm = elms[i];
		elm.value = "";
	    }
	}
    }
}
