
create table wiki_page
    (
        page_name          varchar (100)  not null,
        page_version       integer        not null default 0,
        page_modified      timestamp,
        page_modified_by   varchar (100),
        page_text          clob,
	primary key (page_name)
    );

create index page_modified_ix on wiki_page (page_modified);

create table wiki_page_versions
    (
        version_name          varchar (100)  not null,
        version_num           integer        not null default 0,
        version_modified      timestamp,
        version_modified_by   varchar (100),
        version_text          clob,
	primary key (version_name, version_num)
    );

create table wiki_att
    (
        att_pagename      varchar (100)  not null,
        att_filename      varchar (100)  not null,
        att_version       integer        not null default 0,
        att_modified      timestamp,
        att_modified_by   varchar (100),
        att_data          blob,
	primary key (att_pagename, att_filename, att_version)
    );

create index att_modified_ix on wiki_att (att_modified);

