<%@ page errorPage="/jsp/default/errorpage.jsp" %><%
%><%@ taglib uri="/WEB-INF/wireless_util.tld" prefix="util" %><%
%><%@ taglib uri="/WEB-INF/wireless_mail.tld" prefix="mail" %><%
%><util:nocache/><util:content type="text/plain" /><%
%><?xml version="1.0"?>
<util:include file="docTypeDeclaration.jsp" comp="common"/>

<%-- 
  Copyright 2003 Sun Microsystems, Inc. All Rights Reserved.
  Use is subject to license terms.
--%>

<%--
  ReadMsg.jsp will read the body of the requested message.
  
  This page is responsible for presenting the contents of the email message.
  It will read each paragraph and will also note whether or not the paragraph
  has been quoted in the original message and how many levels of quoting it 
  had (i.e. if the text was preceeded by some number of "<" characters in the
  original).	

  Input parameters:
    JSP:
      msgIndex  - Index of the requested message
      
    VoiceXML:
      p_path - The complete path to the prompt files.

  Output parameters:
    VoiceXML:

  Application root document:
    mailRoot.jsp

  Invoked by:
  
--%>

<mail:context/>

<vxml version="2.0" application="<util:url file="dialogs/mailRoot.jsp" comp="mail"/>">

  <!-- document variables -->
  <var name="userInput" expr="''"/>
  
  <%-- Document grammar --%>
  <link event="whatAreMyChoices">
    <grammar src="<util:url file="grammars/email.grammar" comp="mail" compress="false" includeSid="false"/>#Choices"/>
  </link>

  <form id="main">
    <%-- passed in via a subdialog --%>
    <var name="p_path"/>

    <block>
      <assign name="prompt_path" expr="p_path"/>
      <goto next="#read_message_body"/>
    </block>
  </form>

  <%-- 2.14 Read Message Body --%>
  <form id="read_message_body">
    <var name="quote_level" expr="0"/>
    
    <mail:indentparagraphs index="$(msgIndex)" id="para">
      <var name="size" expr="<mail:get property="size"/>"/>
    </mail:indentparagraphs>

    <property name="timeout" value="3s"/> 
    <field name="option" slot="option">
      <grammar src="<util:url file="grammars/email.grammar" comp="mail" compress="false" includeSid="false"/>#MessageAction"/>

      <prompt bargein="true" cond="size == 0">
        <audio expr="prompt_path + 'end_of_message.wav'"/>
      </prompt>

      <prompt bargein="true" cond="size != 0">
        <mail:indentparagraphs name="para" iterate="true">
          <mail:indentparagraph>
            <util:if property="quoteLevel" value="0">
              <mail:get property="paragraph"/>
            </util:if>

            <util:ifnot property="quoteLevel" value="0">
              <audio expr="prompt_path + 'quote_level.wav'"/>
              <audio expr="prompt_path + '<mail:get property="quoteLevel"/>' + '.wav'"/>

              <break time="100ms" />
              <mail:get property="paragraph"/>
              <break time="100ms" />
            </util:ifnot>
          </mail:indentparagraph>
        </mail:indentparagraphs>

        <break time="750ms"/>
        <audio expr="prompt_path + 'end_of_message.wav'"/>
      </prompt>

      <noinput>
        <assign name="userInput" expr="''"/>
        <goto next="#go_back_to_caller"/>
      </noinput>

      <nomatch count="1">
        <prompt bargein="true">
          <audio expr="prompt_path + 'sorry_i_didnt_get_that.wav'"/>
          <audio expr="prompt_path + 'say_read_it_repeat_it_or_next_or_say_what_are_my_c.wav'"/>
        </prompt>
      </nomatch>

      <nomatch count="2">
        <prompt bargein="true">
          <audio expr="prompt_path + 'sorry_i_still_didnt_get_that.wav'"/>
          <audio expr="prompt_path + 'after_each_message_you_can_say_read_it_delete_it_o.wav'"/>
        </prompt>
      </nomatch>

      <help>
        <prompt bargein="true">
          <audio expr="prompt_path + 'ok_heres_some_help.wav'"/>
          <audio expr="prompt_path + 'after_each_message_you_can_say_read_it_delete_it_o.wav'"/>
        </prompt>
      </help>

      <catch event="whatAreMyChoices">
        <prompt bargein="true">
          <audio expr="prompt_path + 'here_are_your_choices.wav'"/>
          <audio expr="prompt_path + 'after_each_message_you_can_say_read_it_delete_it_o.wav'"/>
        </prompt>
      </catch>

      <filled>
        <assign name="userInput" expr="option"/>
        <goto next="#go_back_to_caller"/>
      </filled>
    </field>
  </form>
  
  <form id="go_back_to_caller">
    <block>
      <return namelist="userInput"/>
    </block>
  </form>

  <%-- Catching global grammars --%>

  <%-- Leaving --%>
  <catch event="goMailMenu">
    <assign name="userInput" expr="'mailMenu'"/>
    <goto next="#go_back_to_caller"/>
  </catch>

  <%-- Main Menu --%>
  <catch event="goMainMenu">
    <assign name="userInput" expr="'mainMenu'"/>
    <goto next="#go_back_to_caller"/>
  </catch>

  <%-- Cancel --%>
  <catch event="goCancel">
    <assign name="userInput" expr="'cancel'"/>
    <goto next="#go_back_to_caller"/>
  </catch>

  <%-- Stop --%>
  <catch event="goStop">
    <assign name="userInput" expr="'stop'"/>
    <goto next="#go_back_to_caller"/>
  </catch>
</vxml>

