<%@ page errorPage="/jsp/default/errorpage.jsp" %><%
%><%@ taglib uri="/WEB-INF/wireless_util.tld" prefix="util" %><%
%><%@ taglib uri="/WEB-INF/wireless_mail.tld" prefix="mail" %><%
%><util:nocache/><util:content type="text/plain" /><%
%><?xml version="1.0"?>
<util:include file="docTypeDeclaration.jsp" comp="common"/>

<%-- 
  Copyright 2003 Sun Microsystems, Inc. All Rights Reserved.
  Use is subject to license terms.
--%>

<%--
  Speaks out a number preceded by one prefix. This prefix can be
  one of the following.

    1. message
    2. read_message
    3. unread_message

  Input parameters:
    JSP:
      speakNum   - Index of the message to be deleted

    VoiceXML:
      msg_type    - Type of the message
                      unread        : Unread message
                      unreadAddrToMe: Unread message addressed to you
                      read          : Read message

      prompt_path - This is where the audio files are
--%>

<%
  // get the index of the message whose headers need to be read out
  String number_as_string = request.getParameter("speakNum");

  int int_value = 0;
  try {
    Integer integer = new Integer(number_as_string);
    int_value = integer.intValue();
  } catch (NumberFormatException e) {
    Float aFloat = new Float(number_as_string);
    int_value = aFloat.intValue();
  }
%>

<vxml version="2.0">

  <%-- Speaks out appropriate message number --%>
  <form id="main">

    <%-- The following are the parameters passed to subdialog --%>
    <var name="msg_type"/>
    <var name="prompt_path"/>

    <var name="speakNum" expr="<%= int_value %>"/>

    <%-- Audio file prefix, computed based on the msg_type --%>
    <var name="audio_file_prefix" expr="'message'"/>

    <block name="compute_audio_file_prefix">
      <if cond="msg_type == 'unread'">
        <assign name="audio_file_prefix" expr="'unread_message'"/>
      <elseif cond="msg_type == 'read'"/>
        <assign name="audio_file_prefix" expr="'read_message'"/>
      <else/>
        <assign name="audio_file_prefix" expr="'message'"/>
      </if>
    </block>

    <block name="play_appropriate_audio_file">
      <if cond="speakNum &gt; 0 &amp;&amp; speakNum &lt;= 9">
        <audio expr="prompt_path + audio_file_prefix + '_' + speakNum + '.wav'"/>
        <goto next="#dialog_done"/> 
      <elseif cond="speakNum &gt; 9"/>
        <audio expr="prompt_path + audio_file_prefix + '.wav'"/>
      </if>
    </block>

    <subdialog name="speak_out_big_number" 
               cond="speakNum &gt; 9" 
               src="<util:url file="dialogs/SpeakNumber.jsp" comp="common"/>" 
               namelist="speakNum">
      <param name="prompt_path" expr="prompt_path"/>
    </subdialog>

    <block>
      <goto next="#dialog_done"/> 
    </block>
  </form>

  <form id="dialog_done">
    <block>
      <return/>
    </block>
  </form>
</vxml>

